diff --git a/drupal7/modules/simpletest/simpletest.info b/drupal7/modules/simpletest/simpletest.info
index b3f78f43..48f4e21f 100644
--- a/drupal7/modules/simpletest/simpletest.info
+++ b/drupal7/modules/simpletest/simpletest.info
@@ -56,8 +56,8 @@ files[] = tests/upgrade/update.trigger.test
 files[] = tests/upgrade/update.field.test
 files[] = tests/upgrade/update.user.test
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/simpletest.module b/drupal7/modules/simpletest/simpletest.module
index 3103af0e..91f0f906 100644
--- a/drupal7/modules/simpletest/simpletest.module
+++ b/drupal7/modules/simpletest/simpletest.module
@@ -328,25 +328,32 @@ function simpletest_test_get_all() {
       // Also discover PSR-0 test classes, if the PHP version allows it.
       if (version_compare(PHP_VERSION, '5.3') > 0) {
 
-        // Select all PSR-0 classes in the Tests namespace of all modules.
+        // Select all PSR-0 and PSR-4 classes in the Tests namespace of all
+        // modules.
         $system_list = db_query("SELECT name, filename FROM {system}")->fetchAllKeyed();
 
         foreach ($system_list as $name => $filename) {
-          // Build directory in which the test files would reside.
-          $tests_dir = DRUPAL_ROOT . '/' . dirname($filename) . '/lib/Drupal/' . $name . '/Tests';
-          // Scan it for test files if it exists.
-          if (is_dir($tests_dir)) {
-            $files = file_scan_directory($tests_dir, '/.*\.php/');
-            if (!empty($files)) {
-              $basedir = DRUPAL_ROOT . '/' . dirname($filename) . '/lib/';
-              foreach ($files as $file) {
-                // Convert the file name into the namespaced class name.
-                $replacements = array(
-                  '/' => '\\',
-                  $basedir => '',
-                  '.php' => '',
-                );
-                $classes[] = strtr($file->uri, $replacements);
+          $module_dir = DRUPAL_ROOT . '/' . dirname($filename);
+          // Search both the 'lib/Drupal/mymodule' directory (for PSR-0 classes)
+          // and the 'src' directory (for PSR-4 classes).
+          foreach(array('lib/Drupal/' . $name, 'src') as $subdir) {
+            // Build directory in which the test files would reside.
+            $tests_dir = $module_dir . '/' . $subdir . '/Tests';
+            // Scan it for test files if it exists.
+            if (is_dir($tests_dir)) {
+              $files = file_scan_directory($tests_dir, '/.*\.php/');
+              if (!empty($files)) {
+                foreach ($files as $file) {
+                  // Convert the file name into the namespaced class name.
+                  $replacements = array(
+                    '/' => '\\',
+                    $module_dir . '/' => '',
+                    'lib/' => '',
+                    'src/' => 'Drupal\\' . $name . '\\',
+                    '.php' => '',
+                  );
+                  $classes[] = strtr($file->uri, $replacements);
+                }
               }
             }
           }
@@ -406,17 +413,20 @@ function simpletest_classloader_register() {
 
   // Only register PSR-0 class loading if we are on PHP 5.3 or higher.
   if (version_compare(PHP_VERSION, '5.3') > 0) {
-    spl_autoload_register('_simpletest_autoload_psr0');
+    spl_autoload_register('_simpletest_autoload_psr4_psr0');
   }
 }
 
 /**
- * Autoload callback to find PSR-0 test classes.
+ * Autoload callback to find PSR-4 and PSR-0 test classes.
+ *
+ * Looks in the 'src/Tests' and in the 'lib/Drupal/mymodule/Tests' directory of
+ * modules for the class.
  *
  * This will only work on classes where the namespace is of the pattern
  *   "Drupal\$extension\Tests\.."
  */
-function _simpletest_autoload_psr0($class) {
+function _simpletest_autoload_psr4_psr0($class) {
 
   // Static cache for extension paths.
   // This cache is lazily filled as soon as it is needed.
@@ -446,14 +456,26 @@ function _simpletest_autoload_psr0($class) {
         $namespace = substr($class, 0, $nspos);
         $classname = substr($class, $nspos + 1);
 
-        // Build the filepath where we expect the class to be defined.
-        $path = dirname($extensions[$extension]) . '/lib/' .
-          str_replace('\\', '/', $namespace) . '/' .
+        // Try the PSR-4 location first, and the PSR-0 location as a fallback.
+        // Build the PSR-4 filepath where we expect the class to be defined.
+        $psr4_path = dirname($extensions[$extension]) . '/src/' .
+          str_replace('\\', '/', substr($namespace, strlen('Drupal\\' . $extension . '\\'))) . '/' .
           str_replace('_', '/', $classname) . '.php';
 
         // Include the file, if it does exist.
-        if (file_exists($path)) {
-          include $path;
+        if (file_exists($psr4_path)) {
+          include $psr4_path;
+        }
+        else {
+          // Build the PSR-0 filepath where we expect the class to be defined.
+          $psr0_path = dirname($extensions[$extension]) . '/lib/' .
+            str_replace('\\', '/', $namespace) . '/' .
+            str_replace('_', '/', $classname) . '.php';
+
+          // Include the file, if it does exist.
+          if (file_exists($psr0_path)) {
+            include $psr0_path;
+          }
         }
       }
     }
diff --git a/drupal7/modules/simpletest/simpletest.test b/drupal7/modules/simpletest/simpletest.test
index dde162ec..f22ef955 100644
--- a/drupal7/modules/simpletest/simpletest.test
+++ b/drupal7/modules/simpletest/simpletest.test
@@ -703,7 +703,9 @@ class SimpleTestDiscoveryTestCase extends DrupalWebTestCase {
     $classes_all = simpletest_test_get_all();
     foreach (array(
       'Drupal\\simpletest\\Tests\\PSR0WebTest',
+      'Drupal\\simpletest\\Tests\\PSR4WebTest',
       'Drupal\\psr_0_test\\Tests\\ExampleTest',
+      'Drupal\\psr_4_test\\Tests\\ExampleTest',
     ) as $class) {
       $this->assert(!empty($classes_all['SimpleTest'][$class]), t('Class @class must be discovered by simpletest_test_get_all().', array('@class' => $class)));
     }
@@ -726,15 +728,20 @@ class SimpleTestDiscoveryTestCase extends DrupalWebTestCase {
       // Don't expect PSR-0 tests to be discovered on older PHP versions.
       return;
     }
-    // This one is provided by simpletest itself via PSR-0.
+    // These are provided by simpletest itself via PSR-0 and PSR-4.
     $this->assertText('PSR0 web test');
+    $this->assertText('PSR4 web test');
     $this->assertText('PSR0 example test: PSR-0 in disabled modules.');
+    $this->assertText('PSR4 example test: PSR-4 in disabled modules.');
     $this->assertText('PSR0 example test: PSR-0 in nested subfolders.');
+    $this->assertText('PSR4 example test: PSR-4 in nested subfolders.');
 
     // Test each test individually.
     foreach (array(
       'Drupal\\psr_0_test\\Tests\\ExampleTest',
       'Drupal\\psr_0_test\\Tests\\Nested\\NestedExampleTest',
+      'Drupal\\psr_4_test\\Tests\\ExampleTest',
+      'Drupal\\psr_4_test\\Tests\\Nested\\NestedExampleTest',
     ) as $class) {
       $this->drupalGet('admin/config/development/testing');
       $edit = array($class => TRUE);
diff --git a/drupal7/modules/simpletest/src/Tests/PSR4WebTest.php b/drupal7/modules/simpletest/src/Tests/PSR4WebTest.php
new file mode 100644
index 00000000..24c8d899
--- /dev/null
+++ b/drupal7/modules/simpletest/src/Tests/PSR4WebTest.php
@@ -0,0 +1,18 @@
+<?php
+
+namespace Drupal\simpletest\Tests;
+
+class PSR4WebTest extends \DrupalWebTestCase {
+
+  public static function getInfo() {
+    return array(
+      'name' => 'PSR4 web test',
+      'description' => 'We want to assert that this PSR-4 test case is being discovered.',
+      'group' => 'SimpleTest',
+    );
+  }
+
+  function testArithmetics() {
+    $this->assert(1 + 1 == 2, '1 + 1 == 2');
+  }
+}
diff --git a/drupal7/modules/simpletest/tests/actions_loop_test.info b/drupal7/modules/simpletest/tests/actions_loop_test.info
index 8c9290b6..023dd086 100644
--- a/drupal7/modules/simpletest/tests/actions_loop_test.info
+++ b/drupal7/modules/simpletest/tests/actions_loop_test.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/tests/ajax.test b/drupal7/modules/simpletest/tests/ajax.test
index c38a325f..afe02306 100644
--- a/drupal7/modules/simpletest/tests/ajax.test
+++ b/drupal7/modules/simpletest/tests/ajax.test
@@ -293,7 +293,7 @@ class AJAXCommandsTestCase extends AJAXTestCase {
     $this->assertCommand($commands, $expected, "'changed' AJAX command (with asterisk) issued with correct selector");
 
     // Tests the 'css' command.
-    $commands = $this->drupalPostAJAX($form_path, $edit, array('op' => t("Set the the '#box' div to be blue.")));
+    $commands = $this->drupalPostAJAX($form_path, $edit, array('op' => t("Set the '#box' div to be blue.")));
     $expected = array(
       'command' => 'css',
       'selector' => '#css_div',
diff --git a/drupal7/modules/simpletest/tests/ajax_forms_test.info b/drupal7/modules/simpletest/tests/ajax_forms_test.info
index 9381926d..c55e0267 100644
--- a/drupal7/modules/simpletest/tests/ajax_forms_test.info
+++ b/drupal7/modules/simpletest/tests/ajax_forms_test.info
@@ -5,8 +5,8 @@ package = Testing
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/tests/ajax_forms_test.module b/drupal7/modules/simpletest/tests/ajax_forms_test.module
index 260d9112..de2fa0ba 100644
--- a/drupal7/modules/simpletest/tests/ajax_forms_test.module
+++ b/drupal7/modules/simpletest/tests/ajax_forms_test.module
@@ -157,7 +157,7 @@ function ajax_forms_test_ajax_commands_form($form, &$form_state) {
 
   // Shows the Ajax 'css' command.
   $form['css_command_example'] = array(
-    '#value' => t("Set the the '#box' div to be blue."),
+    '#value' => t("Set the '#box' div to be blue."),
     '#type' => 'submit',
     '#ajax' => array(
       'callback' => 'ajax_forms_test_advanced_commands_css_callback',
diff --git a/drupal7/modules/simpletest/tests/ajax_test.info b/drupal7/modules/simpletest/tests/ajax_test.info
index 5a28d36a..579d08bc 100644
--- a/drupal7/modules/simpletest/tests/ajax_test.info
+++ b/drupal7/modules/simpletest/tests/ajax_test.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/tests/batch_test.info b/drupal7/modules/simpletest/tests/batch_test.info
index 0932dea0..50613935 100644
--- a/drupal7/modules/simpletest/tests/batch_test.info
+++ b/drupal7/modules/simpletest/tests/batch_test.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/tests/bootstrap.test b/drupal7/modules/simpletest/tests/bootstrap.test
index 14523f28..ece1cd9e 100644
--- a/drupal7/modules/simpletest/tests/bootstrap.test
+++ b/drupal7/modules/simpletest/tests/bootstrap.test
@@ -153,6 +153,8 @@ class BootstrapPageCacheTestCase extends DrupalWebTestCase {
     $this->drupalGet('', array(), array('If-Modified-Since: ' . $last_modified, 'If-None-Match: ' . $etag));
     $this->assertResponse(200, 'Conditional request returned 200 OK for authenticated user.');
     $this->assertFalse($this->drupalGetHeader('X-Drupal-Cache'), 'Absense of Page was not cached.');
+    $this->assertFalse($this->drupalGetHeader('ETag'), 'ETag HTTP headers are not present for logged in users.');
+    $this->assertFalse($this->drupalGetHeader('Last-Modified'), 'Last-Modified HTTP headers are not present for logged in users.');
   }
 
   /**
@@ -286,6 +288,35 @@ class BootstrapVariableTestCase extends DrupalWebTestCase {
 
 }
 
+/**
+ * Tests the auto-loading behavior of the code registry.
+ */
+class BootstrapAutoloadTestCase extends DrupalWebTestCase {
+
+  public static function getInfo() {
+    return array(
+      'name' => 'Code registry',
+      'description' => 'Test that the code registry functions correctly.',
+      'group' => 'Bootstrap',
+    );
+  }
+
+  function setUp() {
+    parent::setUp('drupal_autoload_test');
+  }
+
+  /**
+   * Tests that autoloader name matching is not case sensitive.
+   */
+  function testAutoloadCase() {
+    // Test interface autoloader.
+    $this->assertTrue(drupal_autoload_interface('drupalautoloadtestinterface'), 'drupal_autoload_interface() recognizes <em>DrupalAutoloadTestInterface</em> in lower case.');
+    // Test class autoloader.
+    $this->assertTrue(drupal_autoload_class('drupalautoloadtestclass'), 'drupal_autoload_class() recognizes <em>DrupalAutoloadTestClass</em> in lower case.');
+  }
+
+}
+
 /**
  * Test hook_boot() and hook_exit().
  */
diff --git a/drupal7/modules/simpletest/tests/common.test b/drupal7/modules/simpletest/tests/common.test
index b8ad0cca..0f0347fc 100644
--- a/drupal7/modules/simpletest/tests/common.test
+++ b/drupal7/modules/simpletest/tests/common.test
@@ -1440,6 +1440,127 @@ class JavaScriptTestCase extends DrupalWebTestCase {
     $this->assertTrue(strpos($javascript, $inline) > 0, 'Rendered JavaScript footer returns the inline code.');
   }
 
+  /**
+   * Test the 'javascript_always_use_jquery' variable.
+   */
+  function testJavaScriptAlwaysUseJQuery() {
+    // The default front page of the site should use jQuery and other standard
+    // scripts and settings.
+    $this->drupalGet('');
+    $this->assertRaw('misc/jquery.js', 'Default behavior: The front page of the site includes jquery.js.');
+    $this->assertRaw('misc/drupal.js', 'Default behavior: The front page of the site includes drupal.js.');
+    $this->assertRaw('Drupal.settings', 'Default behavior: The front page of the site includes Drupal settings.');
+    $this->assertRaw('basePath', 'Default behavior: The front page of the site includes the basePath Drupal setting.');
+
+    // The default front page should not use jQuery and other standard scripts
+    // and settings when the 'javascript_always_use_jquery' variable is set to
+    // FALSE.
+    variable_set('javascript_always_use_jquery', FALSE);
+    $this->drupalGet('');
+    $this->assertNoRaw('misc/jquery.js', 'When "javascript_always_use_jquery" is FALSE: The front page of the site does not include jquery.js.');
+    $this->assertNoRaw('misc/drupal.js', 'When "javascript_always_use_jquery" is FALSE: The front page of the site does not include drupal.js.');
+    $this->assertNoRaw('Drupal.settings', 'When "javascript_always_use_jquery" is FALSE: The front page of the site does not include Drupal settings.');
+    $this->assertNoRaw('basePath', 'When "javascript_always_use_jquery" is FALSE: The front page of the site does not include the basePath Drupal setting.');
+    variable_del('javascript_always_use_jquery');
+
+    // When only settings have been added via drupal_add_js(), drupal_get_js()
+    // should still return jQuery and other standard scripts and settings.
+    $this->resetStaticVariables();
+    drupal_add_js(array('testJavaScriptSetting' => 'test'), 'setting');
+    $javascript = drupal_get_js();
+    $this->assertTrue(strpos($javascript, 'misc/jquery.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when only settings have been added includes jquery.js.');
+    $this->assertTrue(strpos($javascript, 'misc/drupal.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when only settings have been added includes drupal.js.');
+    $this->assertTrue(strpos($javascript, 'Drupal.settings') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when only settings have been added includes Drupal.settings.');
+    $this->assertTrue(strpos($javascript, 'basePath') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when only settings have been added includes the basePath Drupal setting.');
+    $this->assertTrue(strpos($javascript, 'testJavaScriptSetting') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when only settings have been added includes the added Drupal settings.');
+
+    // When only settings have been added via drupal_add_js() and the
+    // 'javascript_always_use_jquery' variable is set to FALSE, drupal_get_js()
+    // should not return jQuery and other standard scripts and settings, nor
+    // should it return the requested settings (since they cannot actually be
+    // addded to the page without jQuery).
+    $this->resetStaticVariables();
+    variable_set('javascript_always_use_jquery', FALSE);
+    drupal_add_js(array('testJavaScriptSetting' => 'test'), 'setting');
+    $javascript = drupal_get_js();
+    $this->assertTrue(strpos($javascript, 'misc/jquery.js') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when only settings have been added does not include jquery.js.');
+    $this->assertTrue(strpos($javascript, 'misc/drupal.js') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when only settings have been added does not include drupal.js.');
+    $this->assertTrue(strpos($javascript, 'Drupal.settings') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when only settings have been added does not include Drupal.settings.');
+    $this->assertTrue(strpos($javascript, 'basePath') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when only settings have been added does not include the basePath Drupal setting.');
+    $this->assertTrue(strpos($javascript, 'testJavaScriptSetting') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when only settings have been added does not include the added Drupal settings.');
+    variable_del('javascript_always_use_jquery');
+
+    // When a regular file has been added via drupal_add_js(), drupal_get_js()
+    // should return jQuery and other standard scripts and settings.
+    $this->resetStaticVariables();
+    drupal_add_js('misc/collapse.js');
+    $javascript = drupal_get_js();
+    $this->assertTrue(strpos($javascript, 'misc/jquery.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes jquery.js.');
+    $this->assertTrue(strpos($javascript, 'misc/drupal.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes drupal.js.');
+    $this->assertTrue(strpos($javascript, 'Drupal.settings') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes Drupal.settings.');
+    $this->assertTrue(strpos($javascript, 'basePath') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes the basePath Drupal setting.');
+    $this->assertTrue(strpos($javascript, 'misc/collapse.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes the custom file.');
+
+    // When a regular file has been added via drupal_add_js() and the
+    // 'javascript_always_use_jquery' variable is set to FALSE, drupal_get_js()
+    // should still return jQuery and other standard scripts and settings
+    // (since the file is assumed to require jQuery by default).
+    $this->resetStaticVariables();
+    variable_set('javascript_always_use_jquery', FALSE);
+    drupal_add_js('misc/collapse.js');
+    $javascript = drupal_get_js();
+    $this->assertTrue(strpos($javascript, 'misc/jquery.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes jquery.js.');
+    $this->assertTrue(strpos($javascript, 'misc/drupal.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes drupal.js.');
+    $this->assertTrue(strpos($javascript, 'Drupal.settings') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes Drupal.settings.');
+    $this->assertTrue(strpos($javascript, 'basePath') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes the basePath Drupal setting.');
+    $this->assertTrue(strpos($javascript, 'misc/collapse.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file has been added includes the custom file.');
+    variable_del('javascript_always_use_jquery');
+
+    // When a file that does not require jQuery has been added via
+    // drupal_add_js(), drupal_get_js() should still return jQuery and other
+    // standard scripts and settings by default.
+    $this->resetStaticVariables();
+    drupal_add_js('misc/collapse.js', array('requires_jquery' => FALSE));
+    $javascript = drupal_get_js();
+    $this->assertTrue(strpos($javascript, 'misc/jquery.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added includes jquery.js.');
+    $this->assertTrue(strpos($javascript, 'misc/drupal.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added includes drupal.js.');
+    $this->assertTrue(strpos($javascript, 'Drupal.settings') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added includes Drupal.settings.');
+    $this->assertTrue(strpos($javascript, 'basePath') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added includes the basePath Drupal setting.');
+    $this->assertTrue(strpos($javascript, 'misc/collapse.js') !== FALSE, 'Default behavior: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added includes the custom file.');
+
+    // When a file that does not require jQuery has been added via
+    // drupal_add_js() and the 'javascript_always_use_jquery' variable is set
+    // to FALSE, drupal_get_js() should not return jQuery and other standard
+    // scripts and setting, but it should still return the requested file.
+    $this->resetStaticVariables();
+    variable_set('javascript_always_use_jquery', FALSE);
+    drupal_add_js('misc/collapse.js', array('requires_jquery' => FALSE));
+    $javascript = drupal_get_js();
+    $this->assertTrue(strpos($javascript, 'misc/jquery.js') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added does not include jquery.js.');
+    $this->assertTrue(strpos($javascript, 'misc/drupal.js') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added does not include drupal.js.');
+    $this->assertTrue(strpos($javascript, 'Drupal.settings') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added does not include Drupal.settings.');
+    $this->assertTrue(strpos($javascript, 'basePath') === FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added does not include the basePath Drupal setting.');
+    $this->assertTrue(strpos($javascript, 'misc/collapse.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when a custom JavaScript file that does not require jQuery has been added includes the custom file.');
+    variable_del('javascript_always_use_jquery');
+
+    // When 'javascript_always_use_jquery' is set to FALSE and a file that does
+    // not require jQuery is added, followed by one that does, drupal_get_js()
+    // should return jQuery and other standard scripts and settings, in
+    // addition to both of the requested files.
+    $this->resetStaticVariables();
+    variable_set('javascript_always_use_jquery', FALSE);
+    drupal_add_js('misc/collapse.js', array('requires_jquery' => FALSE));
+    drupal_add_js('misc/ajax.js');
+    $javascript = drupal_get_js();
+    $this->assertTrue(strpos($javascript, 'misc/jquery.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when at least one custom JavaScript file that requires jQuery has been added includes jquery.js.');
+    $this->assertTrue(strpos($javascript, 'misc/drupal.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when at least one custom JavaScript file that requires jQuery has been added includes drupal.js.');
+    $this->assertTrue(strpos($javascript, 'Drupal.settings') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when at least one custom JavaScript file that requires jQuery has been added includes Drupal.settings.');
+    $this->assertTrue(strpos($javascript, 'basePath') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when at least one custom JavaScript file that requires jQuery has been added includes the basePath Drupal setting.');
+    $this->assertTrue(strpos($javascript, 'misc/collapse.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when at least one custom JavaScript file that requires jQuery has been added includes the first custom file.');
+    $this->assertTrue(strpos($javascript, 'misc/ajax.js') !== FALSE, 'When "javascript_always_use_jquery" is FALSE: The JavaScript returned by drupal_get_js() when at least one custom JavaScript file that requires jQuery has been added includes the second custom file.');
+    variable_del('javascript_always_use_jquery');
+  }
+
   /**
    * Test drupal_add_js() sets preproccess to false when cache is set to false.
    */
@@ -1668,6 +1789,15 @@ class JavaScriptTestCase extends DrupalWebTestCase {
     $query_string = variable_get('css_js_query_string', '0');
     $this->assertRaw(drupal_get_path('module', 'node') . '/node.js?' . $query_string, 'Query string was appended correctly to js.');
   }
+
+  /**
+   * Resets static variables related to adding JavaScript to a page.
+   */
+  function resetStaticVariables() {
+    drupal_static_reset('drupal_add_js');
+    drupal_static_reset('drupal_add_library');
+    drupal_static_reset('drupal_get_library');
+  }
 }
 
 /**
diff --git a/drupal7/modules/simpletest/tests/common_test.info b/drupal7/modules/simpletest/tests/common_test.info
index 91507769..c267f1db 100644
--- a/drupal7/modules/simpletest/tests/common_test.info
+++ b/drupal7/modules/simpletest/tests/common_test.info
@@ -7,8 +7,8 @@ stylesheets[all][] = common_test.css
 stylesheets[print][] = common_test.print.css
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/tests/common_test_cron_helper.info b/drupal7/modules/simpletest/tests/common_test_cron_helper.info
index 3c8cb57d..bf615512 100644
--- a/drupal7/modules/simpletest/tests/common_test_cron_helper.info
+++ b/drupal7/modules/simpletest/tests/common_test_cron_helper.info
@@ -5,8 +5,8 @@ version = VERSION
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/tests/database_test.info b/drupal7/modules/simpletest/tests/database_test.info
index 2b8c4e05..fb55d8e4 100644
--- a/drupal7/modules/simpletest/tests/database_test.info
+++ b/drupal7/modules/simpletest/tests/database_test.info
@@ -5,8 +5,8 @@ package = Testing
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2015-03-18
-version = "7.35"
+; Information added by Drupal.org packaging script on 2015-04-02
+version = "7.36"
 project = "drupal"
-datestamp = "1426707463"
+datestamp = "1427943826"
 
diff --git a/drupal7/modules/simpletest/tests/database_test.test b/drupal7/modules/simpletest/tests/database_test.test
index 12ddb343..9c533bed 100644
--- a/drupal7/modules/simpletest/tests/database_test.test
+++ b/drupal7/modules/simpletest/tests/database_test.test
@@ -238,7 +238,7 @@ class DatabaseConnectionTestCase extends DatabaseTestCase {
     // Open the default target so we have an object to compare.
     $db1 = Database::getConnection('default', 'default');
 
-    // Try to close the the default connection, then open a new one.
+    // Try to close the default connection, then open a new one.
     Database::closeConnection('default', 'default');
     $db2 = Database::getConnection('default', 'default');
 
@@ -3454,12 +3454,14 @@ class DatabaseTransactionTestCase extends DatabaseTestCase {
   }
 
   /**
-   * Helper method for transaction unit test. This "outer layer" transaction
-   * starts and then encapsulates the "inner layer" transaction. This nesting
-   * is used to evaluate whether the the database transaction API properly
-   * supports nesting. By "properly supports," we mean the outer transaction
-   * continues to exist regardless of what functions are called and whether
-   * those functions start their own transactions.
+   * Helper method for transaction unit test.
+   *
+   * This "outer layer" transaction starts and then encapsulates the
+   * "inner layer" transaction. This nesting is used to evaluate whether the
+   * database transaction API properly supports nesting. By "properly supports,"
+   * we mean the outer transaction continues to exist regardless of what
+   * functions are called and whether those functions start their own
+   * transactions.
    *
    * In contrast, a typical database would commit the outer transaction, start
    * a new transaction for the inner layer, commit the inner layer transaction,
